// TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Test.h"
#include "DongleController.h"
#include "DongleController_i.c"
#include "TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//globals
IUseDongle * ptrIUseDongle;
int gcount;




// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestDlg dialog
CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_VERIFY_DONGLE, &CTestDlg::OnBnClickedBtnVerifyDongle)
	ON_BN_CLICKED(IDC_BTN_PASS_VERIFY, &CTestDlg::OnBnClickedBtnPassVerify)
	ON_BN_CLICKED(IDOK, &CTestDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BTN_RUN, &CTestDlg::OnBnClickedBtnRun)
	ON_BN_CLICKED(IDC_BTN_STOP, &CTestDlg::OnBnClickedBtnStop)
END_MESSAGE_MAP()


// CTestDlg message handlers
//*************************************************************************************
//*************************************************************************************
//*************************************************************************************
BOOL CTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

//	ptrISetupDongle = NULL;
	ptrIUseDongle = NULL;

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	HRESULT hr = CoInitialize(NULL); // Initialize COM library
	if (FAILED(hr)) { //if initialization fails then exit
		AfxMessageBox(L"Failed to initialize COM library");
		return FALSE;
    }
	//create the com
	hr = CoCreateInstance(CLSID_UseDongle, NULL, 
		                  CLSCTX_INPROC_SERVER, IID_IUseDongle,
			              (LPVOID*) &ptrIUseDongle);
	if (FAILED(hr))
		ptrIUseDongle = NULL;


	CFile file;
	// check if there are any keys in the public file
	if(file.Open(L"public.key", (CFile::modeRead | CFile::typeBinary))) 
	{
		UINT Length = (UINT)file.GetLength();
		if(Length) 
		{
			SAFEARRAYBOUND rgsabound;
			rgsabound.lLbound = 0;
			rgsabound.cElements = Length;
			pPublicKey = SafeArrayCreate(VT_UI1, 1, &rgsabound);
			if(pPublicKey != NULL) 
				file.Read(pPublicKey->pvData, Length);
		}
		file.Close();
	}

	gcount=0;

	CButton *pBtn;
	pBtn = (CButton *)GetDlgItem(IDC_BTN_RUN);
	pBtn->EnableWindow(FALSE);
	pBtn = (CButton *)GetDlgItem(IDC_BTN_STOP);
	pBtn->EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}





void CTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}




void CTestDlg::OnDestroy()
{
	CDialog::OnDestroy();
	CFile file;

	if(ptrIUseDongle) 
		ptrIUseDongle->Release();

	// save the public key to the file
	if(pPublicKey->pvData) 
	{
		long lLength;
		SafeArrayGetUBound(pPublicKey, pPublicKey->cDims, &lLength);
		file.Open(L"public.key", (CFile::modeCreate | CFile::modeReadWrite | CFile::typeBinary));
		file.Write(pPublicKey->pvData, lLength+1);	// 0 based
		file.Close();
	}
	CoUninitialize();
}


void CTestDlg::OnBnClickedBtnVerifyDongle()
{
	HRESULT hr;
	VARIANT_BOOL vb;

	if(ptrIUseDongle) {
		hr = ptrIUseDongle->VerifyDongle(pPublicKey, &vb);
		if (FAILED(hr)) {
			MessageBox(L"Verify call failed");	// proper exception handling required
		}
		else {
			if(vb == VARIANT_TRUE) 
			{
				//the verify process passed so enable the program's buttons
				CButton *pBtn;
				pBtn = (CButton *)GetDlgItem(IDC_BTN_RUN);
				pBtn->EnableWindow(TRUE);
				pBtn = (CButton *)GetDlgItem(IDC_BTN_STOP);
				pBtn->EnableWindow(TRUE);
				//MessageBox(L"Verify dongle passed");	// proper exception handling required
			}
			else 
			{
				MessageBox(L"Signed security dongle not found.");	// proper exception handling required
			}
		}
	}
}


void CTestDlg::OnBnClickedBtnPassVerify()
{
	HRESULT hr;
	VARIANT_BOOL vb;
	CString str;
	GetDlgItemText(IDC_EDT_PASSWORD, str);
	CComBSTR mresult(str);


	if(ptrIUseDongle) {
		hr = ptrIUseDongle->VerifyDonglePassword(pPublicKey, mresult, &vb);
		if (FAILED(hr)) {
			MessageBox(L"Verify call failed");	// proper exception handling required
		}
		else {
			if(vb == VARIANT_TRUE) 
			{
				//the verify process passed so enable the program's buttons
				CButton *pBtn;
				pBtn = (CButton *)GetDlgItem(IDC_BTN_RUN);
				pBtn->EnableWindow(TRUE);
				pBtn = (CButton *)GetDlgItem(IDC_BTN_STOP);
				pBtn->EnableWindow(TRUE);
				//MessageBox(L"Verify dongle Password passed");	// proper exception handling required
			}
			else {
				MessageBox(L"Security dongle not found or password incorrect.");	// proper exception handling required
			}
		}
	}
}

void CTestDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}


void CTestDlg::OnTimer(UINT nIDEvent)
{
	gcount++;
	SetDlgItemInt( IDC_EDT_COUNT, gcount);

	CDialog::OnTimer(nIDEvent);
}

void CTestDlg::OnBnClickedBtnRun()
{
	SetTimer(100, 250, NULL);
}

void CTestDlg::OnBnClickedBtnStop()
{
	KillTimer(100);
}
